﻿Module Main

    Public Class Machine
        Public ComputerName As String
        Public ComputerDescription As String
        Public Username As String
        Public Valid As Boolean
        Public Requested As Boolean
        Public Received As Boolean
    End Class

    Sub Main()
        Console.WriteLine("Find Users v0.1 (c) 2011 Chris")
        Console.WriteLine()
        OutputUsers()
    End Sub

    Private MachinesAndUsers As List(Of Machine)
    Private iThreads As Integer
    Private Sub OutputUsers()
        Dim machines As String = NetView()
        Dim lines() As String = machines.Split(vbCrLf)
        MachinesAndUsers = New List(Of Machine)
        For a As Integer = 0 To lines.Length - 1
            Dim s As String = GetMachineName(lines(a))
            If s = "" Then Continue For
            Dim nm As New Machine
            nm.ComputerName = s
            nm.ComputerDescription = GetComputerDescription(lines(a), s.Length + 3)
            MachinesAndUsers.Add(nm)
        Next

        If MachinesAndUsers.Count = 0 Then
            Console.WriteLine("No computers found by net view")
            Return
        End If

        'ABS-11110            Matt Pougher
        Dim Header As String = ""
        Header += "Computer".PadRight(20)
        Header += "Username".PadRight(20)
        Header += "Desciption"
        Console.WriteLine(Header)
        For Each mac As Machine In MachinesAndUsers
            While iThreads > 31
                Threading.Thread.Sleep(10)
            End While
            Dim p As New RemoteReg(mac.ComputerName)
            mac.Requested = True
            Threading.Interlocked.Increment(iThreads)
            AddHandler p.Completed, AddressOf RemoteRegComplete
            p.Start()
        Next
        While iThreads > 0
            Threading.Thread.Sleep(10)
        End While
        PauseBeforeExit()
    End Sub

    Private Sub RemoteRegComplete(ByVal sender As RemoteReg, ByVal res As RemoteReg.RemoteRegResults)
        RemoveHandler sender.Completed, AddressOf RemoteRegComplete
        Dim o As Machine = MachinesAndUsers.Find(Function(x) x.ComputerName = sender.MachineName)
        o.Received = True
        o.Valid = res.Success
        o.Username = res.Value
        Dim out As String = ""
        out += o.ComputerName.PadRight(20)
        If Not o.Valid Or o.Username Is Nothing Then
            o.Username = GetUsernameFromShare(o.ComputerName)
        End If
        out += o.Username.PadRight(20)
        out += o.ComputerDescription
        Console.WriteLine(out)
        Threading.Interlocked.Decrement(iThreads)
    End Sub

    Private Function NetView() As String
        Dim p As New Process
        p.StartInfo.FileName = "net"
        p.StartInfo.Arguments = "view"
        p.StartInfo.CreateNoWindow = True
        p.StartInfo.RedirectStandardOutput = True
        p.StartInfo.RedirectStandardError = True
        p.StartInfo.UseShellExecute = False
        p.Start()
        Dim out As String = p.StandardOutput.ReadToEnd
        p.Dispose()
        p = Nothing
        Return out
    End Function

    Private Function GetMachineName(ByVal line As String) As String
        Dim start As Integer = line.IndexOf("\\")
        If start = -1 Then Return ""
        start += 2
        Dim finish As Integer = line.IndexOf(" ", start)
        If finish = -1 Then Return ""
        Return line.Substring(start, finish - start)
    End Function

    Private Function GetComputerDescription(ByVal line As String, ByVal start As Integer) As String
        Return line.Substring(start).Trim
    End Function

    Private Function GetUsernameFromShare(ByVal ComputerName As String) As String
        Dim path As String = ""
        If Not System.IO.Directory.Exists("\\" + ComputerName + "\c$") Then Return "*"
        If System.IO.Directory.Exists("\\" + ComputerName + "\c$\Users") Then
            path = "\\" + ComputerName + "\c$\Users"
        ElseIf System.IO.Directory.Exists("\\" + ComputerName + "\c$\Documents and Settings") Then
            path = "\\" + ComputerName + "\c$\Documents and Settings"
        Else
            Return "*"
        End If
        Dim name As String = ""
        Try
            Dim dirs = System.IO.Directory.GetDirectories(path)
            Dim mostrecent As Date
            Dim t As Date
            For Each d In dirs
                t = System.IO.Directory.GetLastWriteTime(d)
                If t > mostrecent Then
                    mostrecent = t
                    name = System.IO.Path.GetFileName(d)
                End If
            Next
        Catch ex As Exception
            name = "*"
        End Try
        Return name
    End Function

    Private Sub PauseBeforeExit()
        Console.WriteLine()
        Console.WriteLine("Press any key to exit")
        Console.ReadLine()
    End Sub
End Module
